
//
// resizer used for chat embeds
//

function resizer(elt, iwidth, iheight) { 

	// first scale all children

	var width = $('#' + elt).innerWidth();
	var scale = width / iwidth;

    if (scale > 1) return;

	console.log('resizer(' + elt + ') scale = ' + width + ' / ' + iwidth + ' = ' + scale);

	$('#' + elt).height(iheight * scale);
	$('#' + elt).children().css("transform", "scale(" + scale + ")");

	// next iterate children and modify their y-offsets

	var offset = 0;

	if (scale > 1) {
		$('#' + elt).children().width(width / scale);
	}

	$('#' + elt).children().each(function() {
		$(this).css({
			'margin-top': parseInt(offset) + 'px',
			'margin-left': parseInt(offset) + 'px'
		});
		offsety = 1 - $(this).height() * (1 - scale);
		offsetx = 1 - $(this).width() * (1 - scale);
	});
}

//
// call resizerSetup() to setup action on any element
//

function resizerSetup(elt) {

	// find the max width of any children and scale to it

	var w = 1;
	var h = $('#' + elt).height();

	$('#' + elt).children().each(function() {
		if ($(this).width() > w) {
			w = $(this).width();
		}
	});

    console.log('resizerSetup(' + elt + ') width=' + w);

	// create a closure to localize the element id if exists

    if ($('#' + elt).length) {
        var t = function() {
            resizer(elt, w, h);
        };

        // call the closure now and on each window resize

        t();
        $(window).resize(t);
    }
}

//
// expand height of element to its parent or to full page body and anchor vertically
//

function resizeHeight(elt, anc)
{
    console.log('resizeHeight()');
    if ($('#' + elt).css('position') != 'absolute') return;
    console.log('resizeHeight() resizing...');

	var r = function() {
        if (anc != null) {
          var off = $('#' + anc).offset();
          $('#' + elt).css({top: off.top});
          $('#' + elt).height( $('body').height() - off.top );
          console.log('resizeHeight(' + elt + ') h=' + ($('body').height() - off.top) + ' o=' + off.top);
        }
        else {
          $('#' + elt).height( $('#' + elt).parent().innerHeight() );
          console.log('resizeHeight(' + elt + ') h=' + $('#' + elt).parent().innerHeight() );
        }
	}

    $(window).on("load", r);
    $(window).resize(r);
}



